=== modified file 'drizzled/definition/table.cc'
--- drizzled/definition/table.cc	2010-12-16 02:16:37 +0000
+++ drizzled/definition/table.cc	2010-12-16 20:27:14 +0000
@@ -1,4 +1,4 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+/* -*- mode: c++; c-basic-offset: 2; i/dent-tabs-mode: nil; -*-
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
  *  Copyright (C) 2010 Brian Aker
@@ -361,7 +361,7 @@
       size_t num_parts= index.index_part_size();
       for (size_t y= 0; y < num_parts; ++y)
       {
-        if (index.index_part(y).fieldnr() == in_field->field_index)
+        if (index.index_part(y).fieldnr() == in_field->position())
           return true;
       }
     }
@@ -398,7 +398,6 @@
   uniques(0),
   null_fields(0),
   blob_fields(0),
-  timestamp_field_offset(0),
   has_variable_width(false),
   db_create_options(0),
   db_options_in_use(0),
@@ -464,7 +463,6 @@
   uniques(0),
   null_fields(0),
   blob_fields(0),
-  timestamp_field_offset(0),
   has_variable_width(false),
   db_create_options(0),
   db_options_in_use(0),
@@ -540,7 +538,6 @@
   uniques(0),
   null_fields(0),
   blob_fields(0),
-  timestamp_field_offset(0),
   has_variable_width(false),
   db_create_options(0),
   db_options_in_use(0),
@@ -619,7 +616,6 @@
   uniques(0),
   null_fields(0),
   blob_fields(0),
-  timestamp_field_offset(0),
   has_variable_width(false),
   db_create_options(0),
   db_options_in_use(0),
@@ -1404,7 +1400,7 @@
     f->setTable(NULL);
     f->orig_table= NULL;
 
-    f->field_index= fieldnr;
+    f->setPosition(fieldnr);
     f->comment= comment;
     if (! default_value &&
         ! (f->unireg_check==Field::NEXT_NUMBER) &&
@@ -1417,9 +1413,6 @@
     if (f->unireg_check == Field::NEXT_NUMBER)
       found_next_number_field= &(field[fieldnr]);
 
-    if (timestamp_field == f)
-      timestamp_field_offset= fieldnr;
-
     if (use_hash) /* supposedly this never fails... but comments lie */
     {
       const char *local_field_name= field[fieldnr]->field_name;
@@ -1854,7 +1847,7 @@
     outparam.found_next_number_field=
       outparam.getField(positionFields(found_next_number_field));
   if (timestamp_field)
-    outparam.timestamp_field= (Field_timestamp*) outparam.getField(timestamp_field_offset);
+    outparam.timestamp_field= (Field_timestamp*) outparam.getField(timestamp_field->position());
 
   /* Fix key->name and key_part->field */
   if (key_parts)

=== modified file 'drizzled/definition/table.h'
--- drizzled/definition/table.h	2010-11-27 23:09:22 +0000
+++ drizzled/definition/table.h	2010-12-16 20:27:14 +0000
@@ -522,7 +522,6 @@
   uint32_t uniques;                         /* Number of UNIQUE index */
   uint32_t null_fields;			/* number of null fields */
   uint32_t blob_fields;			/* number of blob fields */
-  uint32_t timestamp_field_offset;		/* Field number for timestamp field */
 private:
   bool has_variable_width;                  /* number of varchar fields */
 public:

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2010-12-16 18:11:10 +0000
+++ drizzled/field.h	2010-12-16 22:50:48 +0000
@@ -141,7 +141,21 @@
   utype	unireg_check;
   uint32_t field_length; /**< Length of this field in bytes */
   uint32_t flags;
+private:
   uint16_t field_index; /**< Index of this Field in Table::fields array */
+
+public:
+
+  uint16_t position() const
+  {
+    return field_index;
+  }
+
+  void setPosition(uint32_t arg)
+  {
+    field_index= arg;
+  }
+
   unsigned char null_bit; /**< Bit used to test null bit */
   /**
      If true, this field was created in create_tmp_field_from_item from a NULL

=== modified file 'drizzled/field/blob.cc'
--- drizzled/field/blob.cc	2010-11-07 06:43:17 +0000
+++ drizzled/field/blob.cc	2010-12-16 21:42:18 +0000
@@ -520,7 +520,7 @@
                                         bool low_byte_first)
 {
   uint32_t const length= get_length(from, low_byte_first);
-  getTable()->setWriteSet(field_index);
+  getTable()->setWriteSet(position());
   store(reinterpret_cast<const char*>(from) + sizeof(uint32_t),
         length, field_charset);
   return(from + sizeof(uint32_t) + length);

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2010-12-16 02:16:37 +0000
+++ drizzled/filesort.cc	2010-12-16 21:42:18 +0000
@@ -1029,7 +1029,7 @@
     if ((field= sort_field->field))
     {
       if (field->getTable() == table)
-        table->setReadSet(field->field_index);
+        table->setReadSet(field->position());
     }
     else
     {						// Item
@@ -1043,7 +1043,7 @@
     sort_addon_field *addonf= addon_field;
     Field *field;
     for ( ; (field= addonf->field) ; addonf++)
-      table->setReadSet(field->field_index);
+      table->setReadSet(field->position());
   }
   else
   {

=== modified file 'drizzled/function/set_user_var.cc'
--- drizzled/function/set_user_var.cc	2010-12-16 02:16:37 +0000
+++ drizzled/function/set_user_var.cc	2010-12-16 21:42:18 +0000
@@ -91,7 +91,7 @@
   {
     Table *table= (Table *) arg;
     if (result_field->getTable() == table || !table)
-      result_field->getTable()->setReadSet(result_field->field_index);
+      result_field->getTable()->setReadSet(result_field->position());
   }
   return 0;
 }

=== modified file 'drizzled/item/field.cc'
--- drizzled/item/field.cc	2010-12-16 02:16:37 +0000
+++ drizzled/item/field.cc	2010-12-16 21:42:18 +0000
@@ -111,7 +111,7 @@
 {
   Table *table= (Table *) arg;
   if (field->getTable() == table || !table)
-    field->getTable()->setReadSet(field->field_index);
+    field->getTable()->setReadSet(field->position());
 
   return 0;
 }
@@ -902,10 +902,10 @@
       current_bitmap= table->write_set;
       other_bitmap=   table->read_set;
     }
-    //if (! current_bitmap->testAndSet(field->field_index))
-    if (! current_bitmap->test(field->field_index))
+    //if (! current_bitmap->testAndSet(field->position()))
+    if (! current_bitmap->test(field->position()))
     {
-      if (! other_bitmap->test(field->field_index))
+      if (! other_bitmap->test(field->position()))
       {
         /* First usage of column */
         table->used_fields++;                     // Used to optimize loops

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2010-12-02 01:39:53 +0000
+++ drizzled/sql_base.cc	2010-12-16 21:42:18 +0000
@@ -1919,8 +1919,8 @@
       current_bitmap= table->write_set;
     }
 
-    //if (current_bitmap->testAndSet(field->field_index))
-    if (current_bitmap->test(field->field_index))
+    //if (current_bitmap->testAndSet(field->position()))
+    if (current_bitmap->test(field->position()))
     {
       if (session->mark_used_columns == MARK_COLUMNS_WRITE)
         session->dup_field= field;
@@ -2230,9 +2230,9 @@
       {
         Table *table= field_to_set->getTable();
         if (session->mark_used_columns == MARK_COLUMNS_READ)
-          table->setReadSet(field_to_set->field_index);
+          table->setReadSet(field_to_set->position());
         else
-          table->setWriteSet(field_to_set->field_index);
+          table->setWriteSet(field_to_set->position());
       }
     }
   }
@@ -2904,7 +2904,7 @@
       {
         Table *table_1= nj_col_1->table_ref->table;
         /* Mark field_1 used for table cache. */
-        table_1->setReadSet(field_1->field_index);
+        table_1->setReadSet(field_1->position());
         table_1->covering_keys&= field_1->part_of_key;
         table_1->merge_keys|= field_1->part_of_key;
       }
@@ -2912,7 +2912,7 @@
       {
         Table *table_2= nj_col_2->table_ref->table;
         /* Mark field_2 used for table cache. */
-        table_2->setReadSet(field_2->field_index);
+        table_2->setReadSet(field_2->position());
         table_2->covering_keys&= field_2->part_of_key;
         table_2->merge_keys|= field_2->part_of_key;
       }
@@ -3658,7 +3658,7 @@
       if ((field= field_iterator.field()))
       {
         /* Mark fields as used to allow storage engine to optimze access */
-        field->getTable()->setReadSet(field->field_index);
+        field->getTable()->setReadSet(field->position());
         if (table)
         {
           table->covering_keys&= field->part_of_key;

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2010-12-09 18:12:25 +0000
+++ drizzled/sql_insert.cc	2010-12-16 21:42:18 +0000
@@ -129,7 +129,7 @@
       }
       else
       {
-        table->setWriteSet(table->timestamp_field->field_index);
+        table->setWriteSet(table->timestamp_field->position());
       }
     }
   }
@@ -170,8 +170,8 @@
       Unmark the timestamp field so that we can check if this is modified
       by update_fields
     */
-    timestamp_mark= table->write_set->test(table->timestamp_field->field_index);
-    table->write_set->reset(table->timestamp_field->field_index);
+    timestamp_mark= table->write_set->test(table->timestamp_field->position());
+    table->write_set->reset(table->timestamp_field->position());
   }
 
   /* Check the fields we are going to modify */
@@ -189,7 +189,7 @@
 
     if (timestamp_mark)
     {
-      table->setWriteSet(table->timestamp_field->field_index);
+      table->setWriteSet(table->timestamp_field->position());
     }
   }
   return 0;
@@ -1704,7 +1704,9 @@
 
   /* Mark all fields that are given values */
   for (Field **f= field ; *f ; f++)
-    table->setWriteSet((*f)->field_index);
+  {
+    table->setWriteSet((*f)->position());
+  }
 
   /* Don't set timestamp if used */
   table->timestamp_field_type= TIMESTAMP_NO_AUTO_SET;

=== modified file 'drizzled/sql_load.cc'
--- drizzled/sql_load.cc	2010-12-07 18:30:53 +0000
+++ drizzled/sql_load.cc	2010-12-16 21:42:18 +0000
@@ -206,11 +206,13 @@
     */
     if (table->timestamp_field)
     {
-      if (table->isWriteSet(table->timestamp_field->field_index))
+      if (table->isWriteSet(table->timestamp_field->position()))
+      {
         table->timestamp_field_type= TIMESTAMP_NO_AUTO_SET;
+      }
       else
       {
-        table->setWriteSet(table->timestamp_field->field_index);
+        table->setWriteSet(table->timestamp_field->position());
       }
     }
     /* Fix the expressions in SET clause */

=== modified file 'drizzled/sql_update.cc'
--- drizzled/sql_update.cc	2010-12-09 18:12:25 +0000
+++ drizzled/sql_update.cc	2010-12-16 21:42:18 +0000
@@ -98,7 +98,7 @@
   /* Copy the newly read columns into the new record. */
   for (field_p= table->getFields(); (field= *field_p); field_p++)
   {
-    if (unique_map.test(field->field_index))
+    if (unique_map.test(field->position()))
     {
       field->copy_from_tmp(table->getShare()->rec_buff_length);
     }
@@ -189,7 +189,7 @@
       if (table->timestamp_field_type == TIMESTAMP_AUTO_SET_ON_UPDATE ||
           table->timestamp_field_type == TIMESTAMP_AUTO_SET_ON_BOTH)
       {
-        table->setWriteSet(table->timestamp_field->field_index);
+        table->setWriteSet(table->timestamp_field->position());
       }
     }
   }

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2010-12-08 22:35:56 +0000
+++ drizzled/table.cc	2010-12-16 21:42:18 +0000
@@ -521,8 +521,8 @@
     We must set bit in read set as update_auto_increment() is using the
     store() to check overflow of auto_increment values
   */
-  setReadSet(found_next_number_field->field_index);
-  setWriteSet(found_next_number_field->field_index);
+  setReadSet(found_next_number_field->position());
+  setWriteSet(found_next_number_field->position());
   if (getShare()->next_number_keypart)
     mark_columns_used_by_index_no_reset(getShare()->next_number_index);
 }
@@ -571,7 +571,7 @@
     for (reg_field= field ; *reg_field ; reg_field++)
     {
       if ((*reg_field)->flags & PART_KEY_FLAG)
-        setReadSet((*reg_field)->field_index);
+        setReadSet((*reg_field)->position());
     }
   }
 }
@@ -620,7 +620,7 @@
     {
       /* Merge keys is all keys that had a column refered to in the query */
       if (is_overlapping(merge_keys, (*reg_field)->part_of_key))
-        setReadSet((*reg_field)->field_index);
+        setReadSet((*reg_field)->position());
     }
   }
 
@@ -965,7 +965,7 @@
             */
             (*argp)->maybe_null=1;
           }
-          new_field->field_index= fieldnr++;
+          new_field->setPosition(fieldnr++);
 	}
       }
     }
@@ -1012,7 +1012,7 @@
 	group_null_items++;
 	new_field->flags|= GROUP_FLAG;
       }
-      new_field->field_index= fieldnr++;
+      new_field->setPosition(fieldnr++);
       *(reg_field++)= new_field;
     }
     if (!--hidden_field_count)
@@ -1507,7 +1507,7 @@
     for (Field **ptr= this->field ; *ptr != NULL; ptr++)
     {
       Field *f= *ptr;
-      if (write_set->test(f->field_index))
+      if (write_set->test(f->position()))
       {
         if (f->real_maybe_null())
         {
@@ -1540,7 +1540,7 @@
   /* Compare updated fields */
   for (Field **ptr= field ; *ptr ; ptr++)
   {
-    if (isWriteSet((*ptr)->field_index) &&
+    if (isWriteSet((*ptr)->position()) &&
 	(*ptr)->cmp_binary_offset(getShare()->rec_buff_length))
       return true;
   }

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2010-12-07 05:49:18 +0000
+++ drizzled/table.h	2010-12-16 22:49:59 +0000
@@ -603,26 +603,7 @@
   */
   bool operator<(const Table &right) const
   {
-    int result= strcasecmp(this->getShare()->getSchemaName(), right.getShare()->getSchemaName());
-
-    if (result <  0)
-      return true;
-
-    if (result >  0)
-      return false;
-
-    result= strcasecmp(this->getShare()->getTableName(), right.getShare()->getTableName());
-
-    if (result <  0)
-      return true;
-
-    if (result >  0)
-      return false;
-
-    if (this->getShare()->getTableProto()->type()  < right.getShare()->getTableProto()->type())
-      return true;
-
-    return false;
+    return getShare()->getCacheKey() < right.getShare()->getCacheKey();
   }
 
   static bool compare(const Table *a, const Table *b)

=== modified file 'drizzled/transaction_services.cc'
--- drizzled/transaction_services.cc	2010-12-16 02:16:37 +0000
+++ drizzled/transaction_services.cc	2010-12-16 21:42:18 +0000
@@ -1687,7 +1687,7 @@
       bool is_read_set= current_field->isReadSet();
 
       /* We need to mark that we will "read" this field... */
-      in_table->setReadSet(current_field->field_index);
+      in_table->setReadSet(current_field->position());
 
       /* Read the string value of this field's contents */
       string_value= current_field->val_str_internal(string_value);

=== modified file 'plugin/memory/ha_heap.cc'
--- plugin/memory/ha_heap.cc	2010-12-02 01:39:53 +0000
+++ plugin/memory/ha_heap.cc	2010-12-16 21:42:18 +0000
@@ -770,10 +770,10 @@
         auto_key= key+ 1;
 	auto_key_type= field->key_type();
       }
-      if ((uint)field->field_index + 1 > max_key_fieldnr)
+      if ((uint)field->position() + 1 > max_key_fieldnr)
       {
         /* Do not use seg->fieldnr as it's not reliable in case of temp tables */
-        max_key_fieldnr= field->field_index + 1;
+        max_key_fieldnr= field->position() + 1;
       }
     }
   }

=== modified file 'plugin/pbms/src/events_ms.cc'
--- plugin/pbms/src/events_ms.cc	2010-12-05 17:16:03 +0000
+++ plugin/pbms/src/events_ms.cc	2010-12-16 21:42:18 +0000
@@ -90,7 +90,7 @@
 		}
 		
 		// Signal PBMS to delete the reference to the BLOB.
-		err = MSEngine::referenceBlob(data.table.getSchemaName(), data.table.getTableName(), &blob_url_buffer, blob_url, field->field_index, &result);
+		err = MSEngine::referenceBlob(data.table.getSchemaName(), data.table.getTableName(), &blob_url_buffer, blob_url, field->position(), &result);
 		if (err) {
 			// If it fails log the error and continue to try and release any other BLOBs in the row.
 			fprintf(stderr, "PBMSEvents: referenceBlob(\"%s.%s\", \"%s\" ) error (%d):'%s'\n", 
@@ -206,7 +206,7 @@
 	}
 	
 	// Tell PBMS to add a reference to the BLOB.
-	err = MSEngine::referenceBlob(db, table_name, &blob_url_buffer, blob_url, field->field_index, &result);
+	err = MSEngine::referenceBlob(db, table_name, &blob_url_buffer, blob_url, field->position(), &result);
 	if (err) {
 		// If it fails log the error and continue to try and release any other BLOBs in the row.
 		fprintf(stderr, "PBMSEvents: referenceBlob(\"%s.%s\", \"%s\" ) error (%d):'%s'\n", 

=== modified file 'plugin/pbms/src/pbms_enabled.cc'
--- plugin/pbms/src/pbms_enabled.cc	2010-10-18 21:21:20 +0000
+++ plugin/pbms/src/pbms_enabled.cc	2010-12-16 21:42:18 +0000
@@ -135,7 +135,7 @@
 	size_t length;
 	PBMSBlobURLRec blob_url;
 	
-	err = pbms_api.retainBlob(DB_NAME(field), TAB_NAME(field), &blob_url, blob, org_length, field->field_index, result);
+	err = pbms_api.retainBlob(DB_NAME(field), TAB_NAME(field), &blob_url, blob, org_length, field->position(), result);
 	if (err)
 		return err;
 		

=== modified file 'plugin/pbxt/src/myxt_xt.cc'
--- plugin/pbxt/src/myxt_xt.cc	2010-12-16 02:16:37 +0000
+++ plugin/pbxt/src/myxt_xt.cc	2010-12-16 21:42:18 +0000
@@ -2200,7 +2200,7 @@
 			}
 		}
 
-		seg->col_idx = field->field_index;
+		seg->col_idx = field->position();
 		seg->is_recs_in_range = 1;
 		seg->is_selectivity = 1;
 		seg->type = (int) type;
@@ -2314,9 +2314,9 @@
 		/* NOTE: do not set if the field is only partially in the index!!! */
 		if (!partial_field)
 #ifdef DRIZZLED
-			MX_BIT_FAST_TEST_AND_SET(&mi_col_map, field->field_index);
+			MX_BIT_FAST_TEST_AND_SET(&mi_col_map, field->position());
 #else
-			MX_BIT_FAST_TEST_AND_SET(&ind->mi_col_map, field->field_index);
+			MX_BIT_FAST_TEST_AND_SET(&ind->mi_col_map, field->position());
 #endif
 	}
 
@@ -2440,8 +2440,8 @@
 		for (key_part = index->key_part; key_part != key_part_end; key_part++) {
 			curr_field = key_part->field;
 
-			if ((u_int) curr_field->field_index+1 > dic->dic_ind_cols_req)
-				dic->dic_ind_cols_req = curr_field->field_index+1;
+			if ((u_int) curr_field->position()+1 > dic->dic_ind_cols_req)
+				dic->dic_ind_cols_req = curr_field->position()+1;
 		}
 	}
 
@@ -2478,8 +2478,8 @@
 				else
 					max_ave_row_size = 200;
 				large_blob_field_count++;
-				if ((u_int) curr_field->field_index+1 > dic->dic_blob_cols_req)
-					dic->dic_blob_cols_req = curr_field->field_index+1;
+				if ((u_int) curr_field->position()+1 > dic->dic_blob_cols_req)
+					dic->dic_blob_cols_req = curr_field->position()+1;
 				dic->dic_blob_count++;
 				xt_realloc(self, (void **) &dic->dic_blob_cols, sizeof(Field *) * dic->dic_blob_count);
 				dic->dic_blob_cols[dic->dic_blob_count-1] = curr_field;

